NewPositiveMat also for matrices over QQ?  Also NewIntegerOrdMat.  (now called MakeTermOrd)
Status: Closed Start date: 26 Nov 2015

Priority: Immediate Due date:  

Assignee:  % Done: 100%

Category: Tidying Estimated time: 0.99 hour

Target version: CoCoALib-0.99550 spring 2017 Spent time: 0.95 hour

Description

In test-MatrixForOrdering1.C the function NewPositiveMat is called with a matrix containing rational (non-integer) entries.

NewIntegerOrdMat is not documented.  Do we really need/want it?

2016-03 Calling now the new function MakeTermOrd.

The function NewIntegerOrdMat has been removed.

Related issues:

Related to CoCoALib - Bug #834: Fix test failures (after revising MatrixForOr... Closed 09 Dec 2015

Related to CoCoALib - Bug #814: PPOrdering: matrix ordering, what rings are a... Closed 23 Nov 2015

Related to CoCoALib - Design #854: Function MakeTermOrd should be renamed Mak... Closed 24 Mar 2016

Related to CoCoALib - Bug #820: NewMatMinimize, NewMatCompleteOrd - a godfors... Closed 25 Nov 2015

History

#1 - 26 Nov 2015 18:53 - John Abbott

Perhaps the first question should be: do people who build order matrices really start from matrices with rational (non-integer) entries?

Certainly NewPositiveMat can be defined for matrices of rationals; the current impl adds integer multiples of earlier rows to later ones to obtain a

non-negative matrix, but we could even use rational multiples.  Perhaps the fn name should be NewPositiveOrdMat or NewNonNegOrdMat?

The documentation is vague, about exactly how the non-neg matrix is obtained, and this might actually be good for us: we could change the strategy

in future without having to change the documentation. :-)

#2 - 26 Nov 2015 19:04 - John Abbott

Also converting a (non-neg?) matrix of rationals into a matrix of integers defining an equivalent ordering allows for some inventiveness.  Consider this

example:

M := mat(QQ, [[1/3,2/3],[4/5,3/5]]);

We could naively multiply the rows by 3 and 5 respectively to get simply [[1,2],[4,3]]; or we could reduce this result to [[1,2],[1,0]].    

Do we want to give ourselves the freedom to apply some form of "non-negative integer" row reduction to the result?  This is really a question of

semantics: we don't have to implement the reduction, but leave ourselves the opportunity to do so in the future.

Devising an algorithm to do this appeals to me, but I'm not sure whether it would ever actually be useful...

09 Apr 2024 1/2



#3 - 26 Nov 2015 19:10 - John Abbott

If there truly is a need to convert a matrix of rationals into a matrix of integers defining the same term ordering, might it not be better to offer a single

function which does just that.  Internally the fn could make the matrix non-negative, eliminate denoms, and then simplify it.

We could also make the separate steps visible to the public; perhaps some researchers in the area would like to perform the steps separately (maybe

so they can offer us better code?)

The KISS philosophy would suggest offering publicly just a single fn to begin with; then later we can make our private fns accessible if there is

demand.  Remember that once a fn has been made public it is more problematic to change its semantics (or even remove it).

#4 - 24 Mar 2016 12:06 - Anna Maria Bigatti

- Related to Bug #814: PPOrdering: matrix ordering, what rings are allowed. added

#5 - 24 Mar 2016 12:47 - Anna Maria Bigatti

- Subject changed from NewPositiveMat also for matrices over QQ?  Also NewIntegerOrdMat. to NewPositiveMat also for matrices over QQ?  Also

NewIntegerOrdMat.  (now called MakeTermOrd)

- Description updated

- Status changed from New to Feedback

- % Done changed from 0 to 90

#6 - 24 Mar 2016 12:49 - Anna Maria Bigatti

- Related to Design #854: Function MakeTermOrd should be renamed MakeTermOrdMat? added

#7 - 24 Mar 2016 18:08 - Anna Maria Bigatti

- Related to Bug #820: NewMatMinimize, NewMatCompleteOrd - a godforsaken mess! added

#8 - 16 Jun 2016 17:18 - John Abbott

- Target version changed from CoCoALib-0.99540 Feb 2016 to CoCoALib-0.99550 spring 2017

What is the status of this issue?

I'm hoping it can be closed quickly and easily for the next (imminent) release.

#9 - 21 Sep 2016 18:18 - John Abbott

- Priority changed from Normal to Immediate

#10 - 20 Jan 2017 14:26 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time set to 0.99 h

It seems we have taken the approach of making a single function (MakeTermOrd) which is simplest for the user; later oter functions could be made

publicly available.

In feedback for 4 months without problems, so closing.
